<?php

require_once 'lib/database/DAO.class.php';

class xmlDataforChartsFromQuery extends DAO {

    private $xmlChart;
    static protected $db;
    private $query;
    private $serieXfield;
    private $serieYfield;
    private $labelfield;
    private $row;
    private $calculatedData;
    private $title;
    private $absTitle;
    private $ordTitle;
    
    private $serieYfield_array;

    function ChartsFromQuery() {
        $this->calculatedData = false;
    }

    function setQuery($query) {
        $this->query = $query;
    }

    function setSerieXField($serieXfield) {
        $this->serieXfield = $serieXfield;
    }

    function setSerieYField($serieYfield) {
        if (!is_array($serieYfield)) {
            $this->serieYfield = $serieYfield;
        } else {
            $this->serieYfield_array = $serieYfield;
        }
    }

    function setLabelField($labelField) {
        $this->labelfield = $labelField;
    }

    private function executeThisQuery() {
        $_ret = DAO::getResultsFromQuery($this->query);

        if ($_ret >= 0) {
            $this->cursor = DAO::getCursor();
        } else {
            echo "Error";
        }
    }

    function setTitles($title, $absTitle = "", $ordTitle = "") {
        $this->title = $title;
        $this->ordTitle = $ordTitle;
        $this->absTitle = $absTitle;
    }

    private function calculateData() {

        $this->calculatedData = true;
        $this->executeThisQuery();
        $this->xmlChart = new xmlDataforCharts();

        $this->xmlChart->setAbsTitle($this->absTitle);
        $this->xmlChart->setOrdTitle($this->ordTitle);
        $this->xmlChart->setTitle($this->title);

        $multiSerie = array();
        $_row = DAO::getNextRow();

        while ($_row) {
                
            /** SerieYField esta definida, por tanto no esta definida SerieYField_array. 
             *  Esto significa que es una serie única o bien la serie esta dada en las tuplas a lo lardo de los registros, no a lo ancho en columnas
             *  Para el caso de que haya series a lo ancho, entonces ver otro caso.
             */
            if ($this->serieYfield) {
                $seccion = $_row[$this->labelfield];

                if (!is_array($multiSerie[$seccion]))
                    $multiSerie[$seccion] = array();

                $multiSerie[$seccion][$_row[$this->serieXfield]] = $_row[$this->serieYfield];
                
            } else if (is_array ($this->serieYfield_array)) {
                
                foreach ($this->serieYfield_array as $seccion => $serieYfield) {
                                                                                               
                    if (!is_array($multiSerie[$seccion]))  $multiSerie[$seccion] = array();

                    $multiSerie[$seccion][$_row[$this->serieXfield]] = $_row[$serieYfield];
                }
                
            }

            $_row = DAO::getNextRow();
        }
               
        foreach ($multiSerie as $seccion => $arrSerie) {

            $label = $seccion;
            $color = "ff0000";

            $serie = new chartSerie($arrSerie, $label, $color);
            $this->xmlChart->addSerie($serie);
        }
    }

    function getXml() {
        if (!$this->calculatedData)
            $this->calculateData();
        return $this->xmlChart->getXml();
    }

}

class xmlDataforCharts {

    private $xml;
    private $series;
    private $calculated = false;
    private $uniqueXseries;
    private $title;
    private $absTitle;
    private $ordTitle;

    function xmlDataforCharts($title = "") {

        $this->xml = new XmlWriter();
        $this->initXml();
        $this->title = $title;

        $this->series = array();
    }

    function setTitle($title) {
        $this->title = $title;
    }

    function setAbsTitle($absTitle) {
        $this->absTitle = $absTitle;
    }

    function setOrdTitle($ordTitle) {
        $this->ordTitle = $ordTitle;
    }

    function getXml() {

        if (!$this->calculated) {
            $this->calculateXML();
            $this->endXml();
        }

        return $this->xml->outputMemory(true);
    }

    private function initXml() {

        $this->xml->openMemory();
        $this->xml->startDocument('1.0', "UTF-8");
        $this->xml->startElement('chart');
    }

    private function endXml() {

        $this->xml->endElement();
        $this->xml->endDocument();
    }

    function addSerie(chartSerie &$serie) {
        $this->series[] = $serie;
    }

    function calculateUniqueXseries() {
        $this->uniqueXseries = array();
        foreach ($this->series as $serie) {
            foreach ($serie->getValues() as $x => $y) {
                $this->uniqueXseries[$x] = $x;
            }
        }
    }

    private function calculateXML() {

        $this->calculated = true;
        $this->xml->writeAttribute("title", $this->title);
        $this->xml->writeAttribute("absTitle", $this->absTitle);
        $this->xml->writeAttribute("ordTitle", $this->ordTitle);

        $this->calculateUniqueXseries();

        foreach ($this->series as $serie) {

            $this->xml->startElement('series');

            $this->xml->writeAttribute("label", $serie->getLabel());
            $this->xml->writeAttribute("color", $serie->getColor());
            $i = 0;

            $values = &$serie->getValues();
            foreach ($this->uniqueXseries as $x => $x) {

                $y = $values[$x];
                $this->xml->startElement('point');
                $this->xml->writeAttribute("x", $x);
                if (!$y) {
                    $this->xml->writeAttribute("y", floatval(0));
                } else {
                    $this->xml->writeAttribute("y", $y);
                }
                $this->xml->endElement();
                $i++;
            }

            $this->xml->endElement();
        }
    }

}

class chartSerie {

    private $values;
    private $label;
    private $color;

    function chartSerie(Array &$serieValues, $label, $color) {
        $this->values = $serieValues;
        $this->label = $label;
        $this->color = $color;
    }

    function getValues() {
        return $this->values;
    }

    function getLabel() {
        return $this->label;
    }

    function getColor() {
        return $this->color;
    }

}

?>