<?php

require_once 'database/DAO.class.php';


/**
 * Class Provincias
 */
class Provincias extends DAO {

    static protected $table_param = array(
        'table' => 'provincia2',
        'primary_key' => 'pro_id',
        'field_types' => array(
            'pro_id' => 'int',
            'pro_descripcion' => 'varchar'
        )
    );
    public function __construct() {
        self::setTableParam();
    }

    static public function getPrimaryKeyFieldName() {
        return strtolower(Provincias::$table_param['primary_key']);
    }

    static private function setTableParam() {
        parent::$table_param = self::$table_param;
    }

    static public function getTableName() {
        return self::$table_param["table"];
    }

    static public function getProvinciaListForDropDown() {
        self::setTableParam();

        $_ret = false;
        try {

            $_irows = self::getResults(false, "", "pro_descripcion");
            $_ret = array();

            if ($_irows > 0) {
                while ($_data = self::getNextRow()) {
                    if ($_data !== null) {

                        $_ret[] = array(
                            "value" => $_data["pro_descripcion"],
                            "label" => $_data["pro_descripcion"],
                            "id" => $_data["pro_id"]
                        );
                    }
                }
            }

        } catch (Exception $e) {
		var_dump($e);
            echo $e->getMessage();
        }

        return $_ret;
    }


}
