<?php
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
require_once 'MDB2.php';
require_once 'config.database.php';

/**
 * Description of DbConfigclass
 */
class DbConfig extends DbConfigData{

    private static $db;
    private static $cursor;
    

    private static $uniqueResultMySQLWhereFragment = "limit 1";
    private static $uniqueResultOracleWhereFragment = "where rownum = 1";

    public static function getFirstRowSqlSentence(){
        $dsn = DbConfig::getDSN();
        switch (strtolower($dsn['phptype'])){
            case DbConfig::$oracleType:
                return DbConfig::$uniqueResultOracleWhereFragment;
            case DbConfig::$mysqlType:
                return DbConfig::$uniqueResultMySQLWhereFragment;
        }
    }
    
  

    private static function getDBType() {
        $_ret = DbConfig::getDSN();
        return $_ret['phptype'];
    }
    
    public static function setDSN_Mysql(Array $dsn) {
        self::$dsn_mysql = $dsn;
    }
    
    public static function setDSN_OCI8(Array $dsn) {
        self::$dsn_oci8 = $dsn;
    }
    

    public static function isOCI8() {
        return DbConfig::getDBType() == "oci8";
    }

    public static function isMysql() {
        return DbConfig::getDBType() == "mysql";
    }

    public function DbConfig() {
    }

    static function getDBConnection() {
        DbConfig::$db = & MDB2::singleton(DbConfig::getDSN());
        return DbConfig::$db;
    }
    
    static function getDynamicDBConnection($dsnArray) {
        
        DbConfig::$db = & MDB2::singleton($dsnArray);
                
        return DbConfig::$db;
    }
    

    static function isError($cursor=false) {
        
        return PEAR::isError($cursor);
    }

    static function getErrorMessage($cursor) {
        return $cursor->getMessage();
    }

    static function disconnect() {
        if (DbConfig::$db == null) DbConfig::$db = & MDB2::singleton(DbConfig::getDSN());
        DbConfig::$db->disconnect();
    }

    static function getDefaultDateFormat(){
        return self::$dateFormat;
    }

    static function getDefaultDateTimeFormat(){
        return self::$dateTimeFormat;
    }
    
    static function getRDBMSDateTimeFormat(){
        return self::$RDBMS_DateTimeFormat;
    }
    
    static function getRDBMSDateFormat(){
        return self::$RDBMS_DateFormat;
    }
    
    
        
    static function getDefaultNullDateTimeFormat(){
        return self::$dateTimeNullValue;
    }
    
    static function getDefaultNullDateFormat(){
        return self::$dateNullValue;
    }
    
    static function getTableInfo($table) {

        if (DbConfig::isOci8()) {
            
            return self::getOci8_TableInfo($table);
        }else{
            $ret = self::getMysql_TableInfo($table);
            $_databaseName = DbConfig::$db->getDatabase();
            
            $_fk = self::getTableConstraints($_databaseName,$table);
                        
            foreach ($ret as $key => $field){
                if($_fk[$table.".".$field["name"]] != ""){
                    $ret[$key]["fk"] = $_fk[$table.".".$field["name"]];
                }else{
                    $ret[$key]["fk"] = "";
                }
            }
        }
       
        return $ret;

    }
    
    static  function getTableConstraints($dbName,$table){
        if (self::$db === null) self::getDBConnection();
        self::$cursor = self::$db->query("select 
                                            concat(table_name, '.', column_name) as 'foreign key',  
                                            concat(referenced_table_name, '.', referenced_column_name) as 'references'
                                        from
                                            information_schema.key_column_usage
                                        where
                                            referenced_table_name is not null
                                            and table_schema = '".$dbName."' and table_name = '$table'");
        if (!self::isError(self::$cursor)) {
                $numRows = self::$cursor->numRows();
               
               
                while ($_row = self::$cursor->fetchRow(MDB2_FETCHMODE_ASSOC)){
                   
                        
                        $_ret[$_row["foreign key"]] = $_row["references"];
                   
                }
               
        } else {
            die(self::$cursor->getMessage());
        }
        self::disConnect();
        return $_ret;
        
    }

    static private function getMysql_TableInfo($table) {
        if (self::$db === null) self::getDBConnection();
        self::$db->loadModule('Reverse', null, true);
        self::$cursor = self::$db->tableInfo($table, NULL);
        self::disConnect();
        return self::$cursor;
    }
    static private function getOci8_TableInfo($table) {

        $_ret = array();

        if (self::$db === null) self::getDBConnection();
        self::$cursor = self::$db->query("select * from $table where rownum = 1");
        

        if (!self::isError(self::$cursor)) {
                $numRows = self::$cursor->numRows();
               
                if ($numRows > 0) {
                    $_row = self::$cursor->fetchRow(MDB2_FETCHMODE_ASSOC);
                    foreach ($_row as $key => $value) {
                        $_ret[] = array("name"=>$key, "value"=>$value);
                    }
                } else {
                    die("tabla vacia");
                }
        } else {
            die(self::$cursor->getMessage());
        }
        self::disConnect();
        return $_ret;

    }
    
}
?>
